#include "stdafx.h"
#include "module.h"

#define SYMBOLS_WORKAROUND

#define VOUT_NAME "WPF_VLC_VIDEO_OUTPUT"

#ifdef SYMBOLS_WORKAROUND
void LoadSymbols(module_symbols_t* p_symbols);
#endif

module_symbols_t* my_symbols = new module_symbols_t();

/*****************************************************************************
 * Module descriptor
 *****************************************************************************/
vlc_module_begin();

#ifdef SYMBOLS_WORKAROUND
	LoadSymbols(my_symbols);
	p_module->p_symbols = my_symbols;
	p_symbols = my_symbols;
#endif
	
	add_shortcut( VOUT_NAME );
    set_shortname( VOUT_NAME );
    set_description( _("WPF Video Output Module") );
    set_category( CAT_VIDEO );
    set_subcategory( SUBCAT_VIDEO_VOUT );
	set_capability( "video output", 150 );
	set_callbacks( OpenVideo, CloseVideo );

vlc_module_end();

/*################## Workaround for missing symbols ########*/
#ifdef SYMBOLS_WORKAROUND
typedef void * (*__vlc_object_create_inner) (vlc_object_t *, int);
typedef void (*__vlc_object_destroy_inner) (vlc_object_t *);
typedef void (*__vlc_object_attach_inner) (vlc_object_t *, vlc_object_t *);
typedef void (*__vlc_object_detach_inner) (vlc_object_t *);
typedef void * (*__vlc_object_get_inner) (vlc_object_t *, int);
typedef void * (*__vlc_object_find_inner) (vlc_object_t *, int, int);
typedef void (*__vlc_object_yield_inner) (vlc_object_t *);
typedef void (*__vlc_object_release_inner) (vlc_object_t *);
typedef void (*config_Duplicate_inner) (module_t *, module_config_t *);

typedef void (*__msg_Generic_inner) (vlc_object_t *, int, int, const char *, const char *, ... );
typedef void (*__msg_GenericVa_inner) (vlc_object_t *, int, int, const char *, const char *, va_list args);
typedef void (*__msg_Info_inner) (vlc_object_t *, const char *, ... );
typedef void (*__msg_Err_inner) (vlc_object_t *, const char *, ... );
typedef void (*__msg_Warn_inner) (vlc_object_t *, const char *, ... );
typedef void (*__msg_Dbg_inner) (vlc_object_t *, const char *, ... );
typedef msg_subscription_t* (*__msg_Subscribe_inner) (vlc_object_t *, int);
typedef void (*__msg_Unsubscribe_inner) (vlc_object_t *, msg_subscription_t *);

typedef module_t * (*__module_Need_inner) (vlc_object_t *, const char *, const char *, vlc_bool_t);
typedef void (*__module_Unneed_inner) (vlc_object_t *, module_t *);

typedef int (*__vlc_thread_create_inner) (vlc_object_t *, char *, int, char *, void * ( * ) ( void * ), int, vlc_bool_t);
typedef int (*__vlc_thread_set_priority_inner) (vlc_object_t *, char *, int, int);
typedef void (*__vlc_thread_ready_inner) (vlc_object_t *);
typedef void (*__vlc_thread_join_inner) (vlc_object_t *, char *, int);

typedef int (*__var_Create_inner) (vlc_object_t *, const char *, int);
typedef int (*__var_Destroy_inner) (vlc_object_t *, const char *);
typedef int (*__var_Change_inner) (vlc_object_t *, const char *, int, vlc_value_t *, vlc_value_t *);
typedef int (*__var_Type_inner) (vlc_object_t *, const char *);
typedef int (*__var_Set_inner) (vlc_object_t *, const char *, vlc_value_t);
typedef int (*__var_Get_inner) (vlc_object_t *, const char *, vlc_value_t *);
typedef int (*__var_AddCallback_inner) (vlc_object_t *, const char *, vlc_callback_t, void *);
typedef int (*__var_DelCallback_inner) (vlc_object_t *, const char *, vlc_callback_t, void *);

typedef int (*__aout_VolumeGet_inner) (vlc_object_t *, audio_volume_t *);
typedef int (*__aout_VolumeSet_inner) (vlc_object_t *, audio_volume_t);

/*****************************************************************************
 * LoadSymbols: 
 *****************************************************************************/
void LoadSymbols(module_symbols_t* p_symbols)
{
	HMODULE mod = LoadLibrary(TEXT("libvlc"));

	((p_symbols)->__vlc_object_create_inner) = 
		(__vlc_object_create_inner)GetProcAddress(mod, "__vlc_object_create");
	((p_symbols)->__vlc_object_destroy_inner) = 
		(__vlc_object_destroy_inner)GetProcAddress(mod, "__vlc_object_destroy");	
	((p_symbols)->__vlc_object_attach_inner) = 
		(__vlc_object_attach_inner)GetProcAddress(mod, "__vlc_object_attach");	
	((p_symbols)->__vlc_object_detach_inner) = 
		(__vlc_object_detach_inner)GetProcAddress(mod, "__vlc_object_detach");

	((p_symbols)->__vlc_object_get_inner) = 
		(__vlc_object_get_inner)GetProcAddress(mod, "__vlc_object_get");
	((p_symbols)->__vlc_object_find_inner) = 
		(__vlc_object_find_inner)GetProcAddress(mod, "__vlc_object_find");
	
	((p_symbols)->__vlc_object_yield_inner) = 
		(__vlc_object_yield_inner)GetProcAddress(mod, "__vlc_object_yield");
	((p_symbols)->__vlc_object_release_inner) = 
		(__vlc_object_release_inner)GetProcAddress(mod, "__vlc_object_release");

	((p_symbols)->config_Duplicate_inner )=
		(config_Duplicate_inner)GetProcAddress(mod, "config_Duplicate");

	((p_symbols)->__msg_Subscribe_inner) =
		(__msg_Subscribe_inner)GetProcAddress(mod, "__msg_Subscribe");
	((p_symbols)->__msg_Unsubscribe_inner) =
		(__msg_Unsubscribe_inner)GetProcAddress(mod, "__msg_Unsubscribe");
	((p_symbols)->__module_Need_inner) =

		(__module_Need_inner)GetProcAddress(mod, "__module_Need");
	((p_symbols)->__module_Unneed_inner) =
		(__module_Unneed_inner)GetProcAddress(mod, "__module_Unneed");


	((p_symbols)->__vlc_thread_create_inner )=
		(__vlc_thread_create_inner)GetProcAddress(mod, "__vlc_thread_create");
	((p_symbols)->__vlc_thread_join_inner )=
		(__vlc_thread_join_inner)GetProcAddress(mod, "__vlc_thread_join");
	((p_symbols)->__vlc_thread_ready_inner )=
		(__vlc_thread_ready_inner)GetProcAddress(mod, "__vlc_thread_ready");
	((p_symbols)->__vlc_thread_set_priority_inner )=
		(__vlc_thread_set_priority_inner)GetProcAddress(mod, "__vlc_thread_set_priority");

	((p_symbols)->__var_AddCallback_inner )=
		(__var_AddCallback_inner)GetProcAddress(mod, "__var_AddCallback");
	((p_symbols)->__var_Change_inner )=
		(__var_Change_inner)GetProcAddress(mod, "__var_Change");
	((p_symbols)->__var_Create_inner )=
		(__var_Create_inner)GetProcAddress(mod, "__var_Create");
	((p_symbols)->__var_DelCallback_inner )=
		(__var_DelCallback_inner)GetProcAddress(mod, "__var_DelCallback");
	((p_symbols)->__var_Destroy_inner )=
		(__var_Destroy_inner)GetProcAddress(mod, "__var_Destroy");
	((p_symbols)->__var_Get_inner )=
		(__var_Get_inner)GetProcAddress(mod, "__var_Get");
	((p_symbols)->__var_Set_inner )=
		(__var_Set_inner)GetProcAddress(mod, "__var_Set");
	((p_symbols)->__var_Type_inner )=
		(__var_Type_inner)GetProcAddress(mod, "__var_Type");

	((p_symbols)->__aout_VolumeGet_inner )=
		(__aout_VolumeGet_inner)GetProcAddress(mod, "__aout_VolumeGet");
	((p_symbols)->__aout_VolumeSet_inner )=
		(__aout_VolumeSet_inner)GetProcAddress(mod, "__aout_VolumeSet");
	

}
#endif

/*****************************************************************************
 * OpenVideo: 
 *****************************************************************************/
static int OpenVideo( vlc_object_t *p_this )
{
	//MessageBox(NULL, TEXT("OpenVideo"), TEXT("OpenVideo"), MB_OK);
    vout_thread_t * p_vout = (vout_thread_t *)p_this;

	// Only one video output can work at a time
	if(p_vout->p_sys != NULL)
		return VLC_EGENERIC;

	p_vout->p_sys = new vout_sys_t;
    if( !p_vout->p_sys ) return VLC_ENOMEM;
	p_vout->p_sys->p_pic_buffer = NULL;

	// Set the functions
    p_vout->pf_init = InitVideo;
    p_vout->pf_end = EndVideo;
    p_vout->pf_manage = ManageVideo;
    p_vout->pf_render = RenderVideo;
    p_vout->pf_display = DisplayVideo;
	p_vout->pf_control = ControlVideo;

    return VLC_SUCCESS;
}

/*****************************************************************************
 * CloseVideo: 
 *****************************************************************************/
static void CloseVideo( vlc_object_t *p_this )
{
	EndVideo((vout_thread_t *)p_this);
}

/*****************************************************************************
 * InitVideo: 
 *****************************************************************************/
static int InitVideo( vout_thread_t *p_vout )
{
    picture_t *p_pic;

	I_OUTPUTPICTURES = 0;

    // Initialize the output structure
	// We want 24-bit output

	/*
	//RGB 24
    p_vout->output.i_chroma = VLC_FOURCC('R','V','2','4');
	p_vout->output.i_rmask  = 0x00ff0000;
    p_vout->output.i_gmask  = 0x0000ff00;
    p_vout->output.i_bmask  = 0x000000ff;

	p_pic = &p_vout->p_picture[0];

    p_vout->output.i_width  = p_vout->render.i_width;
    p_vout->output.i_height = p_vout->render.i_height;
    p_vout->output.i_aspect = p_vout->render.i_aspect;
    p_pic->p->i_lines = p_vout->output.i_height;
    p_pic->p->i_visible_lines = p_vout->output.i_height;
    p_pic->p->i_pixel_pitch = 3;
    p_pic->p->i_pitch = p_vout->render.i_width * 3;		// Pitch = number of pixels in a row * 24bits
	p_pic->p->i_visible_pitch = p_pic->p->i_pitch;
	*/

	//BGR 32
	p_vout->output.i_chroma = VLC_FOURCC('R','V','3','2');
	p_vout->output.i_rmask  = 0x00ff0000;
    p_vout->output.i_gmask  = 0x0000ff00;
    p_vout->output.i_bmask  = 0x000000ff;
	
	p_pic = &p_vout->p_picture[0];

	p_vout->output.i_width  = p_vout->render.i_width;
    p_vout->output.i_height = p_vout->render.i_height;
    p_vout->output.i_aspect = p_vout->render.i_aspect;

	p_pic->p->i_lines = p_vout->output.i_height;
    p_pic->p->i_visible_lines = p_vout->output.i_height;
    p_pic->p->i_pixel_pitch = 4;
    p_pic->p->i_pitch = p_vout->render.i_width * 4;
	p_pic->p->i_visible_pitch = p_pic->p->i_pitch;
   
	// Allocate Memory for the Image
	p_vout->p_sys->p_pic_buffer = new unsigned char[
		p_vout->render.i_height * p_pic->p->i_pitch];

	p_pic->p->p_pixels = p_vout->p_sys->p_pic_buffer;
  
    p_pic->i_planes = 1;
    p_pic->i_status = DESTROYED_PICTURE;
    p_pic->i_type = DIRECT_PICTURE;

    PP_OUTPUTPICTURE[ I_OUTPUTPICTURES++ ] = p_pic;

	// Connect Video
	if(p_vout->p_sys->p_pic_buffer)
	{
		IntPtr^ p_buffer = gcnew IntPtr(p_vout->p_sys->p_pic_buffer);
		
		p_video_output->InitializeVideoImage(
			p_vout->output.i_width, 
			p_vout->output.i_height, 
			(float)p_vout->output.i_aspect / VOUT_ASPECT_FACTOR, 
			*p_buffer,
			p_vout->render.i_height * p_pic->p->i_pitch, 
			p_pic->p->i_pitch);
	}

    return VLC_SUCCESS;
}

/*****************************************************************************
 * EndVideo: 
 *****************************************************************************/
static void EndVideo( vout_thread_t *p_vout )
{
	if(p_vout->p_sys != NULL)
	{
		if(p_vout->p_sys->p_pic_buffer != NULL)
		{
			delete[] p_vout->p_sys->p_pic_buffer;
			p_vout->p_sys->p_pic_buffer = NULL;
		}

		delete p_vout->p_sys;
		p_vout->p_sys = NULL;
	}
}

/*****************************************************************************
 * ManageVideo: 
 *****************************************************************************/
static int ManageVideo( vout_thread_t *p_vout )
{
    return VLC_SUCCESS;
}

/*****************************************************************************
 * RenderVideo: 
 *****************************************************************************/
static void RenderVideo( vout_thread_t *p_vout, picture_t *p_pic )
{
    vout_sys_t *p_sys = p_vout->p_sys;
}

/*****************************************************************************
 * DisplayVideo: 
 *****************************************************************************/
static void DisplayVideo( vout_thread_t *p_vout, picture_t *p_pic )
{
    vout_sys_t *p_sys = p_vout->p_sys;

	IntPtr^ p_buffer = gcnew IntPtr(p_vout->p_sys->p_pic_buffer);

	if(p_sys != NULL && p_vout->p_sys->p_pic_buffer != NULL )
	{
		p_video_output->RenderVideoImage(*p_buffer);
	}
	p_buffer = nullptr;
}

/*****************************************************************************
 * ControlVideo: 
 *****************************************************************************/
static int ControlVideo( vout_thread_t *p_vout, int i_query, va_list args )
{
	return VLC_SUCCESS;
}